##############################################################
# This file contains the logic to process the modem inf
#
# Sept 18, 1996  Created	ReenaA
# Jan  06, 1997  Modified	CostelR
#
##############################################################
########################################################################
#
# Package with version constants
#
########################################################################
{ package PRSECVersion;

  $BuildVersion = "1.00.0019";
}

require('addreg.pl');

%ModemErrorTable = (
	3033 => ["Illegal characters in string %s."],
	3034 => ["Rank0 and Rank1 cant be the same."],
	3035 => ["PCMCIA\\ prefix required for PCMCIA-modem id."],
	3036 => ["PCMCIA id required."], 
	3037 => ["UNIMODEM id required for PCMCIA-modems."], 
	3038 => ["Star (*) format ID should be used for ISAPNP modems."],
	3039 => ["UNIMODEM id required for SERENUM-modems."],
	3040 => ["Star (*) format ID should be used for BIOS modems."],
	3041 => ["UNIMODEM id required for STAR-modems."],
	3042 => ["Keyword ADDREG not defined."],
	3043 => ["UNIMODEM id is not of the expected length."],
	3044 => ["Section [%s.POSDUP] expected but missing."],
	3045 => ["Section [%s.NORESDUP] expected but missing."],
	3046 => ["\"HKR, %s\" already defined in this section. Keep last definition."],
	3047 => ["Mandatory field &ltKey&gt is missing."],
	3048 => ["Field &ltFormat&gt should be 0 or 1."],
	3049 => ["Mandatory field &ltValue&gt is missing."],
	3050 => ["%s does not have any Answer."],
	3051 => ["%s does not have any Hangup."],
	3052 => ["%s does not have any Init."],
	3053 => ["%s does not have any Reset."],
	3054 => ["More than one Reset in model %s."],
	3055 => ["%s does not have any Monitor."],
	3056 => ["%s does not have any Settings,Prefix."],
	3057 => ["%s does not have any Settings,DialPrefix."],
	3058 => ["%s does not have any Settings,DialSuffix."],
	3059 => ["%s does not have any Settings,Terminator."],
	3060 => ["%s does not have any Responses."],
	3061 => ["%s does not have any Properties."],
	3062 => ["%s has more than one \"Properties\" entry."],
	3063 => ["%s does not have any InactivityScale."],
	3064 => ["%s\'s properties expect a key \"Settings, %s\" which is not defined."],
	3065 => ["%s: Command %s, level #%d not found."],
	3066 => ["%s: Command %s, levels #%d-#%d not found."],
	3067 => ["AT Command should not start with spaces"],
	3068 => ["AT-Command \"None\" should not end with \"&ltCR&gt\"."],
	3069 => ["AT-Command \"None\" suspicious."],
	3070 => ["AT-Command \"NoResponse\" should not end with \"&ltCR&gt\"."],
	3071 => ["AT-Command \"NoResponse\" suspicious."],
	3072 => ["AT-Command string should start with \"AT\"."],
	3073 => ["AT-Command string should end with \"&ltCR&gt\"."],
	3074 => ["Old key - cant be used any more."],
	3075 => ["Expect &ltKey&gt to be a quoted string."],
	3076 => ["&ltKey&gt cant be empty string."],
	3077 => ["Expect response to be in binary."],
	3078 => ["Properties should have 8 DWORDS."],
	3079 => ["InactivityScale should have 1 DWORD."],
	3080 => ["&ltValue&gt is expected to have only hex digits."],
	3081 => ["Expect &ltValue&gt to be a quoted string."],
	3082 => ["&ltValue&gt cant be empty string."],
	3083 => ["&ltValue&gt should have doubled %%'s."],

	3085 => ["\"Reboot\" and \"Restart\" are not functional in modem INFs"],
	3086 => ["Section [%s] is empty. It should contain \"*PNP0500\"."],
	3087 => ["String \"*PNP0500\" is missing for section [%s]."],
	3088 => ["Wrong strings in section [%s]. Only \"*PNP0500\" is allowed."],
	3089 => ["A verbosity response of either V1 or V0 must be given"],
	3090 => ["Empty INF file"],
	3091 => ["UNIMODEM id required for MF-modems."],
	3092 => ["%s has more than one \"DCB\" entry."],
	3093 => ["DCB structure should have 26 bytes."],
	3094 => ["%s has more than one \"DeviceType\" entry."],
	3095 => ["%s does not have any DeviceType."],
	3096 => ["Too many bytes defined for DeviceType entry."],
	3097 => ["DeviceType should be 01, 02 or 03."],
	3098 => ["230K port declared for external device %s."],
	3099 => ["VoiceProfile should have 4 bytes."],
	3100 => ["%s: Monitor suspicious. Expect 1: \"ATS0=0&ltcr&gt\" and 2: \"None\"."],
	3101 => ["SERENUM modem: no unimodem ID is permitted for the same parameterization."],
	3102 => ["Identifier %s, only UNIMODEM ids allowed in NORESDUP section."],
	3103 => ["SERENUM modem and matched model %s: friendly names are the same."],

	3105 => ["%s, duplicate rank 0 Id in file(s) \"%s\"."],
	3106 => ["Voice modem %s, minimal voice keys not present (Enumerator, VoiceProfile)."],
	3107 => ["Key value should be \"serwave.vxd\"."],
	3108 => ["PnP ID declared rank 1 or greater (probably rank 0). Use one PnP rank 0 ID per device."],
	3109 => ["Responses should have 10 bytes."],
	3110 => ["No Star (*) format  ISAPNP or BIOS modem using this section."],
	3111 => ["No SERENUM modem uses this section."],

	3114 => ["Wrong value for response state."],
	3115 => ["Wrong value for negotiated option."],
	3116 => ["Numeric response does not agree with the response state."],
	3117 => ["The response contains no keyword for the state 0x%02x (%s)."],
	3118 => ["The response contains no keyword for \"%s\" option (0x%02x)."],
	3119 => ["The response suggests \"%s\", but the corresponding bit is not set."],
	3120 => ["\"Negotiated options\" byte should not be used for \"%s\" state."],
	3121 => ["Speeds should not be used for \"%s\" state."],
	3122 => ["Speed value in response string is not %d."],
	3123 => ["Missing %d basic numeric responses: %s."],
	3124 => ["\"V1\" found but verbose responses are missing."],
	3125 => ["\"V\" or \"V0\" found but numeric responses are missing."],
	3126 => ["Speed %d reported but dword value is missing."],
	3127 => ["Missing %d basic verbose responses: %s."],
	3128 => ["Duplicated response (line %d)."],
	3129 => ["Additional response \"%s\" should be given when stripped responses are used."],
	);

%ModemWarningTable = (
	4013 => ["%s : only one PnP id type is recommended."],
	4014 => ["First field should be one of the HKR, HKU, HKLM, HKCR or HKCU keywords."],
	4015 => ["%s: VoiceView may not be supported in future."],
	4016 => ["%s: Answer suspicious. Expect \"ATA&ltcr&gt\"."],
	4017 => ["%s: Hangup suspicious. Expect \"ATH&ltcr&gt\"."],
	4018 => ["%s: Init not robust. Expect \"%s\" also."],
	4019 => ["%s: Reset suspicious. Expect \"ATZ&ltcr&gt\" or \"AT&F..&ltcr&gt\"."],
	4020 => ["%s: first dword speed exceeds maximum value (%d) given in Properties."],
	4021 => ["%s: Settings, Prefix suspicious. Expect \"AT\"."],
	4022 => ["%s: Settings, DialPrefix suspicious. Expect \"D\"."],
	4023 => ["%s: Settings, DialSuffix suspicious. Expect \"\" or \";\"."],
	4024 => ["%s: Settings, Terminator suspicious. Expect \"&ltcr&gt\"."],
	4025 => ["%s: Same &ltValue&gt for at least two of SpeakerVolume_XXX Settings."],
	4026 => ["%s: Same &ltValue&gt for at least two of SpeakerMode_XXX Settings."],
	4027 => ["%s: Same &ltValue&gt for Compression_On/Off Settings."],
	4028 => ["%s: Same &ltValue&gt for ErrorControl_On/Off/Forced Settings."],
	4029 => ["%s: VoiceView strings discontinued."],
	4030 => ["%s: Same &ltValue&gt for ErrorControl_Cellular/Cellular_Forced Settings."],
	4031 => ["%s: Same &ltValue&gt for at least two of FlowControl_XXX Settings."],
	4032 => ["%s: Same &ltValue&gt for Modulation_XXX Settings."],
	4033 => ["%s: Possible inversion of &ltValue&gt between Settings Modulation_CCITT/Bell."],
	4034 => ["%s: Same &ltValue&gt for SpeedNegotiation_On/Off Settings."],
	4035 => ["%s: Possible inversion of &ltValue&gt between Settings SpeedNegotiation_On/Off."],
	4036 => ["%s: Same &ltValue&gt for Tone/Pulse Settings."],
	4037 => ["%s: Possible inversion of &ltValue&gt between Settings Tone/Pulse."],
	4038 => ["%s: Same &ltValue&gt for Blind_On/Off Settings."],
	4039 => ["%s: Possible inversion of &ltValue&gt between Settings Blind_On/Off."],
	4040 => ["Command \"%s\" should not terminate in AT&ltcr&gt."],
	4041 => ["If Rockwell chipset, enable ForceBlindDial & SetBaudBeforeWave bits. Otherwise, ignore warning."],
	4042 => ["SVD key(s) illegal."],
	4043 => ["Inactivity timer value is not 0, 90 or 255."],
	4044 => ["Setup timer value is not 0 or 255."],
	4045 => ["Second dword used to report the speed. Usually first dword is used."],
	4046 => ["\"Error control\" bit is set, may be OK, but usually means only compression."],
	4047 => ["Too many numeric responses (verbose setting in Init)."],
	4048 => ["Too many verbose responses (numeric setting in Init)."],
	4049 => ["Responses matching pattern \"%s\" not found for speeds %s."],
	4050 => ["Both padded &ltcr&gt&ltlf&gt and unpadded response styles are used."],
	4051 => ["%s: DTE speed exceeds maximum value (%d) given in Properties."],
	4052 => ["Separate sound mixer chip required."],
	4053 => ["Obsolete key."],
	4054 => ["The response suggests \"%s\" state (0x%02x), while first byte gives \"%s\"."],
	4055 => ["PnP id \"%s\" requires ExcludeFromSelect. Vendors or INF floppy install users may ignore this message."],
);

$PrintModemR0Statistics = 0;	# Modem INF specific : global check for Rank0 Ids
&InitModemGlobals();			# Modem INF specific : init global variables

########################################################################
sub
InitModemGlobals
{

%GlobalR0List=();
$NumR0Errs = 0;
$StrR0Errs = "";

%ErrorTable = (%ErrorTable, %ModemErrorTable);
%WarningTable = (%WarningTable, %ModemWarningTable);
$ShortErrorReport = 1;

if (!defined($ReportScript) || $ReportScript == 0)
{
	print "Short error report (Yes/No) [Y] ? ";
	$ResponseErrorReport = <STDIN>;
	chop $ResponseErrorReport;
	$ShortErrorReport = 0 if ($ResponseErrorReport =~ /^No{0,1}$/i);
}

@VoiceViewStrings =	(	"APPS_DESC",
						"StartUp_DESC",
						"SendTo_DESC",
						"FileXfer_DESC",
						"SendToPhone_DESC",
						"StartXfer_DESC"
					);

%NumRespMatching	= (	0 => 0x00, 1 => 0x02, 2 => 0x08, 3 => 0x04, 4 => 0x03,
						5 => 0x02, 6 => 0x05, 7 => 0x06, 8 => 0x07 );

#	ResponseState	=> [ [keyword, Flag] ]

# Matching Flags
# 0 (most of them) - if matching, property is set
# 1 (like in "COMPRESSION : NONE") - if mathcing, property shouldn't be set
# 2 (MNP 5, CLASS 5, V42BIS) - implies compression as well, informative, 
#								works only with compression, should not covere 
#								the others, low priority

$ForceNotSet = 1;		# if matching, the response is no,
$DependentOnCompression	 = 2;

%NegotiatedOptionComment = (	0x01	=> "Compression",
								0x02	=> "Error control", 
								0x08	=> "Cellular protocol"
							);

%NegotiatedOptionLookup		= (
			# Compression
						0x01	=>	[	['\bADC\b', 0],
										['\bCLASS *5\b', 0],
										['\bCOMP(RESS(ED|ION)){0,1}\b', 0],
										['\bNONE\b', $ForceNotSet],
										['\bEC(LC|\-DC)\b', 0],
										['\bMNP *(LEVEL){0,1} *5\b', 0],
										['\bREL *(\-){0,1} *5\b', 0],
										['\bV\.{0,1}42 *B(IS){0,1}\b', 0],
										['\bVBIS\b', 0],
										['\bX\.{0,1}70 *(BTX|NL)\b', 0],
										['\bX\.{0,1}75\b', 0],
									],
			# Error control
						0x02	=>	[	['\bALT(ERNATE|\-EC){0,1}\b', 0],
										['\bARQ\b', 0],
										['\bCLASS *[2-4]\b', 0],
										['\bCLASS *5\b', $DependentOnCompression],
										['\bEC(L|LC|\-DC){0,1}\b', 0],
										['\bERROR *\-{0,1} *CONTROL\b', 0],
										['\bLAP(_|\-){0,1}(M|B)\b', 0],
										['\bMNP *(LEVEL){0,1} *[1-4]\b', 0],
										['\bMNP(?! *5)', 0],
										['\bMNP *5\b', $DependentOnCompression],
										['\bPAD\b', 0],
										['\bREL *[1234]\b', 0],
										['\bREL(C|IABLE){0,1}', 0],
										['\bRLP\b', 0],
										['\bSLIP\b', 0],
										['\bV\.{0,1}14\b', 0],
										['\bV\.{0,1}42(?!( *B(IS){0,1}))', 0],
										['\bV\.{0,1}42 *B(IS){0,1}\b', $DependentOnCompression],
										['\bX\.{0,1}70 *(BTX|NL)\b', 0],
										['\bX\.{0,1}(75|25)\b', 0],
									],
			# Cellular protocol
						0x08	=>	[	['\bCELL(ULAR){0,1}\b', 0],
										['\bMNP10\b', 0],
										['\bETC\b', 0],
									],
								);

%ResponseStateComment = (		0x00	=> "OK",
								0x01	=> "Negotiation Progress", 
								0x02	=> "Connect",
								0x03	=> "Error",
								0x04	=> "No Carrier",
								0x05	=> "No Dialtone",
								0x06	=> "Busy",
								0x07	=> "No Answer",
								0x08	=> "Ring",
								0x09	=> "VoiceView: SSV",
								0x0A	=> "VoiceView: SMD",
								0x0B	=> "VoiceView: SFA",
								0x0C	=> "VoiceView: SRA",
								0x0D	=> "VoiceView: SRQ",
								0x0E	=> "VoiceView: SRC",
								0x0F	=> "VoiceView: STO",
								0x10	=> "VoiceView: SVM",
								0x18	=> "Single Ring",
								0x19	=> "Double Ring",
								0x1a	=> "Triple Ring",
								0x1b	=> "Sierra DTMF",
								0x91	=> "Ring duration",
								0x92	=> "Ring break",
								0x93	=> "Date",
								0x94	=> "Time",
								0x95	=> "Number",
								0x96	=> "Name",
								0x97	=> "Message",
							);
%ResponseStateLookup		= (
				#OK
						0x00	=>	[	['^OK$', 0],
										['^\#{0,1}VCON$', 0],
										['^VOICE$', 0],
									],
				#Negotiation Progress
						0x01	=>	[	['^\#V(IL|UR)$', 0],
										['^<cr>$', 0],
										['^<lf>$', 0],
										['^<ff><cr>$', 0],
										['^<H00>$', 0],
										['^CARRIER\b', 0],
										['^CED$', 0],
										['^COMPRESSION\b', 0],
										['^DIALING$', 0],
										['^ERRM *=', 0],
										['^RING(ING| *BACK)$', 0],
										['^RRING$', 0],
										['\bSPEED *SETUP\b', 0],
										['^OFF *HOOK$', 0],
										['^PROTOCOL(?!.*\bFAX\b)\b', 0],		# but no FAX after that
										['^AUTOSTREAM\b', 0],
									],
				#Connect
						0x02	=>	[	['^CONNECT\b', 0],
										['^CLIENT *SERVER$', 0],
									],
				#Error
						0x03	=>	[	['\+F4\b', 0],
										['(\+|\-|\b)FC( *ERROR){0,1}\b', 0],
										['^\+FCON$', 0],
										['^ABOR(D|TED)$', 0],
										['\bBLACKLISTED\b', 0],
										['^DATA$', 0],
										['\bDELAY(ED){0,1}\b', 0],
										['^ERROR$', 0],
										['\bFAIL(ED){0,1}\b', 0],
										['\bFAX\b', 0],
										['^LOCKED$', 0],
										['\bNO *USER\b', 0],
										['\bSTOP\b', 0],
										['\bTIMEOUT\b', 0],
										['\bUN *(\-){0,1} *OBTAINABLE', 0],
										['^VOICE$', 0],
										['\bWAIT\b', 0],
									],
				# No Carrier
						0x04	=>	[	['^NO *CARRIER$', 0],
										['^DISCONNECT$', 0],
									],
				# No Dialtone
						0x05	=>	[	['^NO *DIAL *TONE$', 0],
									],
				# Busy
						0x06	=>	[	['^BUSY$', 0],
									],
				# No Answer
						0x07	=>	[	['^NO *ANSWER$', 0],
									],
				# Ring
						0x08	=>	[	['^RING$', 0],
										['^<HFF>$', 0],
										['^DIAL *IN$', 0],
										['^(<H00>){0,1}CLIENT$', 0],
										['^<H10>R$', 0],
									],
				# VoiceView
						0x09	=>	[	['\bSSV\b', 0],
									],
						0x0A	=>	[	['\bSMD\b', 0],
									],
						0x0B	=>	[	['\bSFA\b', 0],
									],
						0x0C	=>	[	['\bSRA\b', 0],
									],
						0x0D	=>	[	['\bSRQ\b', 0],
									],
						0x0E	=>	[	['\bSRC\b', 0],
									],
						0x0F	=>	[	['\bSTO\b', 0],
									],
						0x10	=>	[	['\bSVM\b', 0],
									],

				# Single Ring
						0x18	=>	[	['^RING *(A|1)$', 0],
									],
				# Double Ring
						0x19	=>	[	['^RING *(B|2)$', 0],
									],
				# Triple Ring
						0x1a	=>	[	['^RING *(C|3)$', 0],
									],
				# Sierra DTMF
						0x1b	=>	[	['^\#VD[\#\*0-9ABCDGT]$', 0],
										['^\#VI[RS]$', 0],
										['^\#VT[HO]$', 0],
									],
				# Voice: Ring duration
						0x91	=>	[	['^DRON *=$', 0],
									],
				# Voice: Ring break
						0x92	=>	[	['^DROF *=$', 0],
									],
				# Voice: Date
						0x93	=>	[	['^DATE *=$', 0],
									],
				# Voice: Time
						0x94	=>	[	['^TIME *=$', 0],
									],
				# Voice: Number
						0x95	=>	[	['^CALR *=$', 0],
										['^CID *=$', 0],
										['^NMBR *=$', 0],
									],
				# Voice: Name
						0x96	=>	[	['^NAME *=$', 0],
									],
				# Voice: Message
						0x97	=>	[	['^MESG *=$', 0],
									],
					);

%ResponseSpeeds		= (	75	=> 0, 240	=> 0, 300	=> 0, 600	=> 0, 1200	=> 0, 1275	=> 0,
						2400	=> 0, 2600	=> 0, 4800	=> 0, 5000	=> 0, 7200	=> 0, 7400	=> 0, 9600	=> 0,
						9800	=> 0, 12000	=> 0, 12200	=> 0, 14000	=> 0, 14400	=> 0, 14600	=> 0, 16000	=> 0,
						16800	=> 0, 17000	=> 0, 19200	=> 0, 19400	=> 0, 21400	=> 0, 21600	=> 0, 21800	=> 0,
						24000	=> 0, 24200	=> 0, 26400	=> 0, 26600	=> 0, 26800	=> 0, 28800	=> 0, 29000	=> 0,
						31200	=> 0, 31400	=> 0, 32000	=> 0, 33600	=> 0,
						33800	=> 0, 38400	=> 0, 48000	=> 0, 56000	=> 0, 57600	=> 0, 64000	=> 0, 
						76800	=> 0, 115200	=> 0, 230400	=> 0, 112000	=> 0, 128000	=> 0
					);



########################################################################
#
# Package with Identifier Types (do not change them, work like constants)
#
# Usage: $IdType'UNIMODEM_ID
#
########################################################################

{ package IdType;
  
  $UNIMODEM_ID	= "U";
  $PCMCIA_ID	= "P";
  $SERENUM_ID	= "S";
  $ISAPNP_ID	= "I";
  $BIOS_ID	= "B";
  $STAR_ID	= "*";
  $MF_ID	= "M";
  $UNKNOWN_ID	= "K";
}

########################################################################
#
# Package with Install Types (do not change them, work like constants)
#
# Usage: $InstallType'PCMCIA_INST
#
########################################################################

{ package InstallType;
  
  $PCMCIA_INST	= "P";
  $UNKNOWN_INST = "K";
}

}


#------------------------------------------------------------
#------------------------------------------------------------
sub
InitModemVars
{

	%InstallIDTypes=();	   # This array has (ModelInstSec, IDsType) tuples.
						   # used for checking SERENUM and STAR modems

	%InstallTypeList=();	   # This array has (ModelInstSec, InstallType) tuples.

	# List of sections referenced. - Initialised to stand alone sections.
	@SecRef=(@SecRef, "VVIEW.REM.INIS", "VOICEVIEW_MODEM", "VOICEVIEW_SOCKET");

	%AddRegList=();		#	InstallSection => [ RefHKRList, RefResponseStructs] 
						#	RefHKRList is a hash indexed by first two keys in HKR line
						#	RefResponseStructs is a list of references to 
						#			[ResponseStringIndex, LineNumber, RefResponseStruct] 

	%ATSyntaxErr=();	# pairs of (line_no, err_no), used in CheckATString()

	$PrintModemR0Statistics = 1;	# Modem INF specific : global check for Rank0 Ids

	%VoiceInstallList=();	# list of Install sections that has a minimum of keys to be considered 
							# a valid Voice Install section
	%InstallProps	= ();	#	InstallSection =>
							#			[ [PropertiesStruct], [DCBStruct], [InitSettings] ]
	$ModelKeys{"REBOOT"}	= "CheckRebootRestart";
	$ModelKeys{"RESTART"}	= "CheckRebootRestart";

}


#------------------------------------------------------------
#------------------------------------------------------------
sub
ModemCheck
{
local(	@list, $manu, $ManuInfo, $key, $InstSection,
	$ModelInfo, $ModelDescription, $ManuDescription);

	# look for the models defined under the manufacturers

	&ModelIDTypes();

	# Process ADDREG sections for each install section
	&CheckInstSections;

	# check if the voice modems conatins a minimal install keys
	&CheckVoice();

	# Check ID integrity
	&CheckIds();

	#substitute manu and model names from Fstr into ManuList and ModelList.
	# modem specific
	while (($key, $ManuInfo) = (each %ManuList)) 
	{
		$ManuDescription = $$ManuInfo[0];
		if ($ManuDescription =~ /^%(.)*%$/) 
		{
			if (defined $FStr{uc $ManuDescription}) 
			{
				$$ManuInfo[0] = $FStr{uc $ManuDescription};
			}
		}
	}
	while (($key, $ModelInfo) = (each %ModelList)) 
	{
		$ModelDescription = $$ModelInfo[0];
		if ($ModelDescription =~ /^%(.)*%$/) 
		{
			if (defined $FStr{uc $ModelDescription}) 
			{
				$name = $FStr{uc $ModelDescription};
#				add_ref_err("Illegal characters in string $ModelDescription.", ($SecEnd{'STRINGS'} -1))
				add_ref_err(3033, ($SecEnd{'STRINGS'} -1), $ModelDescription)
					if ($name =~ /[\^\/:\|"<>]|\.$/);
				$$ModelInfo[0] = $name;
			}
		}
	}
	# print "DEBUG: main: ManuList ", %ManuList, "\n";
	# print "DEBUG: main: ModelList ", %ModelList, "\n";


	# gather dangling sections, strings. (modem specific)
	&modem_section_usage();

	&modem_string_usage();

	if ( ($count = %ManuList) == 0)
	{
		&EmptyINF();
	}
}

#------------------------------------------------------------
# This sub also checks for proper posdup and noresdup sections.
#
# Globals changed:
#
# Usage: 
#		modem_section_usage()
#------------------------------------------------------------

sub 
modem_section_usage
{
	local($sec, $model, $count);
	foreach $sec (sort keys %SecStart)
	{
	if ($sec =~ /(.+)\.NORESDUP/)
	{
		$model = $1;
		if(($count = grep(($sec eq $_), @SecRef)) < 1)
		{
			add_ref_err(3111, $SecStart{$sec}); # SERENUM
		}
		&checkNORESDUP($sec, 1);
		next;
	}
	if ($sec =~ /(.+)\.POSDUP/)
	{
		$model = $1;
		if(($count = grep(($sec eq $_), @SecRef)) < 1)
		{
			add_ref_err(3110, $SecStart{$sec}); # STAR Modems
		}
		&checkPOSDUP($sec);
		next;
	}
	}
}

#------------------------------------------------------------
# This sub also checks for string usage.
#
# Globals changed:
#
# Usage: 
#		modem_string_usage()
#------------------------------------------------------------

sub 
modem_string_usage
{
	local($VVString, $LLnum);

	$LLnum = $SecEnd{$StrSec};
	foreach $VVString (@VoiceViewStrings)
	{
		next if ($VVString =~ /^$/);
		if( defined($FStr{uc "%$VVString%"}) )
		{
			add_ref_wrn(4029, $LLnum-1, $VVString);
			@RefStr = (@RefStr, uc "%$VVString%");
		}
	}
}


#-------------------------------------------------------------
#
# Glafs an error for Reboot Restart keyords.
#
# Globals changed:
#
# Usage:
#
#-------------------------------------------------------------
sub
CheckRebootRestart
{
local($key, $Line_num) = @_;

	if ($key =~ /REBOOT/i || $key =~ /RESTART/i)
	{	add_ref_err(3085,$Line_num); }
}

#-------------------------------------------------------------
#
# This sub prints the summary for this files' mfgs and models.
#
# Globals changed:
#
# Usage:
#
#-------------------------------------------------------------
sub 
ModemSummary
{

local($name, @list, @id0, @id1, $id1, $id0, @list2, $model, @id2, $id2, $ExType, $ExcludeRef);
local($ExcludeKey, $ExcludeLine);

	#print summary for this file

	print "<PRE>\n";

	#print manu name (substituted from strings section.), 
	foreach $key (sort keys %ManuList) 
	{
		$ManuInfo = $ManuList{$key};
		$name = $$ManuInfo[0];	   #manu name.
		print "<FONT SIZE=+2><FONT COLOR=GREEN><B>Mfg:</FONT> ";
		print "$name</B></FONT>\n"; 	#manu name.

		# model names and model info: rank0, rank1 etc.
		@list = @{$$ManuInfo[1]};
		while ($model = shift (@list))
		{
			print "\n";
			$ModelInfo = $ModelList{uc $model};

			print "   <FONT SIZE=+1><FONT COLOR=GREEN><B>Model:</FONT> "; 
			print "$$ModelInfo[0]</B></FONT>\n";	  #model name.

			@id0 = @{$$ModelInfo[2]};
			@id1 = @{$$ModelInfo[3]};
			@id2 = @{$$ModelInfo[4]};
			foreach $id0 (@id0) 
			{
				print "   <FONT SIZE=+0><FONT COLOR=GREEN>Rank0:</FONT> "; 
				print "$id0</FONT>\n";

				$id1 = shift(@id1);
		undef($id1) if ($id1 =~ /^$/);
		$id2 = shift(@id2);
		undef($id2) if ($id2 =~ /^$/);
		if (defined($id1) || defined($id2))
		   {  print "   <FONT SIZE=+0><FONT COLOR=GREEN>Rank1:</FONT> "; 
			  print "$id1</FONT>\n";
		   }
		if (defined ($id2))
		  { print "   <FONT SIZE=+0><FONT COLOR=GREEN>Rank2:</FONT> "; 
					print "$id2</FONT>\n";
		  }


			  if (defined ($ExcludeRef = $ExSelList{uc $id0}))
			  {
				while (($ExcludeKey, $ExcludeLine) = each %$ExcludeRef)
				{
					print "    Excluded from Select.\n" if ($ExcludeKey =~ /^EXCLUDEFROMSELECT$/i);
					print "    Excluded from Select in NT.\n" if ($ExcludeKey =~ /^EXCLUDEFROMSELECT.NT$/i);
				}
			  }
			  print "\n";
			}
		}
		print "\n";
	}
	
	print "</PRE>\n";
}	 


######################################################
#
#	Main logic subs.
#
######################################################
#-------------------------------------------------------------
#
# prcesses the GlobalR0List to check for duplicates.
#
# Globals changed:
#
# Usage:
#
#-------------------------------------------------------------

sub
proc_AllR0
{

	foreach $ID (keys %GlobalR0List)
	{
	if ($GlobalR0List{$ID} =~ /,/)
	{
		add_ref_R0_err($ID, $GlobalR0List{$ID});
	}
	}
}

#------------------------------------------------------------
# This sub adds to the list of Rank0 errors. (modem specifc)
#
# Usage: 
#		add_ref_R0_err(ID, files)
#------------------------------------------------------------
sub add_ref_R0_err
{
local($ID, $files) = @_;
local($str);

	@files = split(/, /, $files);
	$str = "<br><tr>\n<td><font color=#904040>$ID</font></td>\n";
	$str = join("", $str, "<td><pre>$files[0]</pre></td>\n</tr>\n");
	shift (@files); 
	foreach $file (@files) 
	{
		$str = join("", $str, "<tr>\n<td></td>\n<td><pre>$file</pre></td>\n</tr>\n");
	}

	$StrR0Errs[$NumR0Errs] = $str;
	$NumR0Errs++;

}

#-------------------------------------------------------------
#
# Analyse rank ids for all models defined
#
# Globals changed:
#	ModelList
#
# Usage:
#	ModelIDTypes()
#
#-------------------------------------------------------------
sub 
ModelIDTypes
{
local($ModelKey, $ModelInfo, $inst, $sz, $r);
local($id_item, @rank0, @rank1, @rank2, @lines, @rank, $Type);

	while (($ModelKey, $ModelInfo) = each (%ModelList) )
	{	$inst	= $$ModelInfo[1];

	@rank0	= @{$$ModelInfo[2]};
	@rank1	= @{$$ModelInfo[3]};
	@rank2	= @{$$ModelInfo[4]};
	@lines	= @{$$ModelInfo[5]};

	$InstallTypeList{$inst} = $InstallType'UNKNOWN_INST; # placeholder....

	if (! defined ($InstallIDTypes{$inst}) )
	   {	$InstallIDTypes{$inst} = "";
	   }

	push(@{$ModelInfo}, "");

		# Upper case
	$sz = @rank0;		# all arrays should have the same length
		for($id_item = 0; $id_item < $sz; $id_item++)
	{	$rank0[$id_item] = uc ($rank0[$id_item]) ;
		$rank1[$id_item] = uc ($rank1[$id_item]) ;
		$rank2[$id_item] = uc ($rank2[$id_item]) ;

		@rank = ();
		push(@rank, $rank0[$id_item], $rank1[$id_item], $rank2[$id_item]); 
		
		$Type = &GetRankType($inst, $lines[$id_item], @rank);

		$InstallIDTypes{$inst} .= $Type;

			$$ModelInfo[7] .= $Type;
	}
	}

}

#-------------------------------------------------------------
# 
# Globals changed:
#
# Usage:
#	GetRankType($inst_section, $Cur_line_num, id_array);
#
# Returns:
#	Modem Type (PCMCIA, SERENUM, STAR, MF)
#-------------------------------------------------------------
sub
GetRankType
{
local ($inst, $CLnum, @id ) = @_;
local ($rank0, $rankNext, $sz, $Type, $TypeCur, $Count, $bError, $ExcludeRef);

		# Process Rank0 id
	$rank0 = $id[0];

	$Type = $IdType'UNKNOWN_ID;
	if ($rank0 !~ /^$/)
	{
		$Type = checkR0($rank0, $inst, $CLnum);
		if (($Type cmp $IdType'SERENUM_ID) == 0 || ($Type cmp $IdType'STAR_ID) == 0)
		{
			if (!defined($ExcludeRef = $ExSelList{uc $rank0}) || 
				!defined($$ExcludeRef{'EXCLUDEFROMSELECT'}) )
			{
				add_ref_wrn(4055, $CLnum, $rank0);
			}
		}

		AddGlobR0($rank0, $CLnum) if ($Type !~ /$IdType'UNKNOWN_ID/);

#		add_ref_err("Rank0 and Rank1 cant be the same.", $CLnum) 
		add_ref_err(3034, $CLnum) 
					if ($id[0] eq $id[1]);
	}

		# Process next ranks
	$Count = 1;
	$rankNext = $id[$Count];
		$bError = 0;
	while (1)
	  { if (defined $rankNext)
		  {  
		$TypeCur = checkR0($rankNext, $inst, $CLnum);

		if (($TypeCur cmp $IdType'SERENUM_ID) == 0 || ($TypeCur cmp $IdType'STAR_ID) == 0)
		{
			if (!defined($ExcludeRef = $ExSelList{uc $rankNext}) || 
				!defined($$ExcludeRef{'EXCLUDEFROMSELECT'}))
			{
				add_ref_wrn(4055, $CLnum, $rankNext);
			}
		}
			# establish the type as the first UNKNOWN
			# 
		if ($TypeCur ne $IdType'UNKNOWN_ID)
		  {
			if ($Type ne $IdType'UNKNOWN_ID)
				# ambiguous rank type
			{ 
				add_ref_err(3108, $CLnum)
					if ($bError == 0);
				$bError = 1;
			}
			 else
			{ $Type = $TypeCur;
			}
		  }
		  }
		$Count++;
		last if $Count > 2; # At most three ranks allowed

		$rankNext = $id[$Count];
	  }
	$Type;			# return value
}

#-------------------------------------------------------------
# 
# Find a model that a Serenum modem could match
# 
#-------------------------------------------------------------
sub SerenumMatch
{
local($InstSection)=@_;
local(@UnimodemIds, $Id);
local($IdRef, $ModelRef);

	@UnimodemIds = ();

	@UnimodemIds = &checkNORESDUP("$InstSection.NORESDUP",0);

	foreach $Id (@UnimodemIds)
	{
		next if (!defined($IdRef = $AllIDList{uc $Id}));
		next if (!defined($ModelRef = $ModelList{uc $$IdRef[0]}));
		if ( ((uc $$ModelRef[1]) cmp (uc $InstSection)) == 0)
		{	return($$IdRef[0]); }
	}
	return undef;
}



#-------------------------------------------------------------
# 
# Check modem ids consistency. 
#		- If PCMCIA flag in the install section, one id is prefixed with either
#		"PCMCIA\", "SERENUM\", "MF\" or "*"
#		and an UNIMODEM id must be present.
#		- If SERENUM, PCMCIA, STAR, MF type an UNIMODEM id must be present.
#		- Error if more than one type SERENUM, STAR, MF or PCMCIA.
#
#
# Globals changed:
#
# Usage:
#	CheckIds($section_name)
#
#-------------------------------------------------------------
sub 
CheckIds
{
local($sec) = @_;			# expected section name.
local($InstSection, $Model, $ModelProp, @Properties, @IdLine, $IdIndex);
local($IsUNKNOWN, $IsPCMCIA, $IsSERENUM, $IsUNIMODEM, 
	$IsSTAR, $IsMF, $SpecialIdCount);
local($bUnimodemRequired, $Type, $SerenumMatchModel);

#		iterate Install sections

	while (($Model, $ModelProp) = each(%ModelList))
	{ 
		$Model = $$ModelProp[0];
		@IdLine = @{$$ModelProp[5]};
		$InstSection = $$ModelProp[1];
		$Type	= $$ModelProp[7];

		$IsUNKNOWN = index( $Type, $IdType'UNKNOWN_ID);
		$IsPCMCIA  = index( $Type, $IdType'PCMCIA_ID);
		$IsSERENUM = index( $Type, $IdType'SERENUM_ID);
		$IsMF	   = index( $Type, $IdType'MF_ID);
		$IsUNIMODEM =index( $Type, $IdType'UNIMODEM_ID);
		$IsSTAR =index( $Type, $IdType'STAR_ID);
	
		# conflict types
		$SpecialIdCount = ($IsPCMCIA >= 0) + ($IsSERENUM >= 0) + ($IsSTAR >= 0) + ($IsMF >= 0);
	#	add_ref_wrn("$Model : only one PnP id type is recommended.", $$ModelProp[6])
		add_ref_wrn(4013, $$ModelProp[6], $Model)
			if ($SpecialIdCount > 1);

		if ($IsSTAR >= 0)
		{
			if (!defined ($SecStart{uc "$InstSection.POSDUP"}))
			{
				#	add_ref_err("Section [$InstSection.POSDUP] expected but missing.", $TotalLines)
				add_ref_err(3044, $IdLine[$IsSTAR], $InstSection);
			}
			else
			{
				push(@SecRef, uc "$InstSection.POSDUP");
			}
		}

		$bUnimodemRequired = 0;

		# PCMCIA is present in Install Section
		if ( index( $InstallTypeList{$InstSection},
					$InstallType'PCMCIA_INST) >= 0	)
		{
			$IdIndex = $IsUNKNOWN;
			# Unknown ids without PCMCIA prefix
			while ($IdIndex >= 0)
			 { 
				#	add_ref_err("PCMCIA\\ prefix required for PCMCIA-modem id.", $IdLine[$IdIndex] );
				add_ref_err(3035, $IdLine[$IdIndex] );
				$IdIndex = index( $Type, $IdType'UNKNOWN_ID, $IdIndex+1);
			 }
		 
			# has a UNIMODEM id but no PCMCIA, SERENUM, UNKNOWN
			if ( $IsUNIMODEM >= 0 && 
				$IsSTAR < 0 &&
				$IsPCMCIA < 0 &&
				$IsSERENUM < 0 && 
				$IsMF < 0 && 
				$IsUNKNOWN < 0)
			{
				# a SERENUM or STAR modem can refer to this Install section that has only
				# a UNIMODEM ID
				# still is not a SERENUM or STAR
				if ( index( $InstallIDTypes{$InstSection}, $IdType'SERENUM_ID) < 0 && 
					 index( $InstallIDTypes{$InstSection}, $IdType'STAR_ID) < 0 )
				{
					#	add_ref_err("$Model : PCMCIA id required.", $$ModelProp[6]);
					add_ref_err(3036, $IdLine[$IsUNIMODEM]);
				}
			}
			# is unknown and no UNIMODEM id
			if ( $IsUNKNOWN >= 0 && 
				 $IsUNIMODEM < 0 && 
				 !$bUnimodemRequired )
			{ 
				#  add_ref_err("$Model : UNIMODEM id required for PCMCIA-modems.", $$ModelProp[6]);
				add_ref_err(3037, $IdLine[$IsUNKNOWN]);
				$bUnimodemRequired = 1;
			}
		}

		# special test for SERENUM and STAR modems
		if ($IsSERENUM >= 0)
		{
			if ($IsUNIMODEM >= 0)
			{
				#	"SERENUM modem: no unimodem ID is permitted for the same parameterization."
				add_ref_err(3101, $IdLine[$IsUNIMODEM]);
			}
			if (!defined ($SecStart{uc "$InstSection.NORESDUP"}))
			{
				#	add_ref_err("Section [$InstSection.NORESDUP] expected but missing.", $TotalLines)
				add_ref_err(3045, $IdLine[$IsSERENUM], $InstSection);
			}
			else
			{
				push(@SecRef, uc "$InstSection.NORESDUP");
				$SerenumMatchModel = &SerenumMatch($InstSection);

				# has a SERENUM prefix but no UNIMODEM id
				if (!defined($SerenumMatchModel))
				{ 
					#add_ref_err("$Model : UNIMODEM id required for SERENUM-modems.", $$ModelProp[6]);
					add_ref_err(3039, $IdLine[$IsSERENUM]);
				}
				if ( ((uc $SerenumMatchModel) cmp (uc $Model)) != 0 &&
					 ($FStr{uc $SerenumMatchModel} cmp $FStr{uc $Model}) == 0
					)
				{	
					add_ref_err(3103, $IdLine[$IsSERENUM], $SerenumMatchModel);
				}
			}
		}

		# search for UNIMODEM id in the modems installed in the section
		if ($IsUNIMODEM < 0 && $IsSTAR >= 0)
		{	$IsUNIMODEM = index( $InstallIDTypes{$InstSection}, $IdType'UNIMODEM_ID);
		}

		if (!$bUnimodemRequired && $IsUNIMODEM < 0)
		{
		# has a PCMCIA prefix but no UNIMODEM id
		if ($IsPCMCIA >= 0)
		{ 
			# add_ref_err("$Model : UNIMODEM id required for PCMCIA-modems.", $$ModelProp[6]);
			add_ref_err(3037, $IdLine[$IsPCMCIA]);
		}

		# has a MF prefix but no UNIMODEM id
		if ($IsMF >= 0)
		{ 
			#add_ref_err("$Model : UNIMODEM id required for MF-modems.", $$ModelProp[6]);
			add_ref_err(3091, $IdLine[$IsMF]);
		}

		# has a STAR prefix but no UNIMODEM id
		if ($IsSTAR >= 0)
		{ 
			#add_ref_err("$Model : UNIMODEM id required for STAR-modems.", $$ModelProp[6]);
			add_ref_err(3041, $IdLine[$IsSTAR]);
		}
	}

	}
}

#-------------------------------------------------------------
# 
# Checks [XXX.POSDUP] section for STAR models. 
#
# Usage:
#	checkPOSDUP(PosdupSection)
#
#-------------------------------------------------------------
sub 
checkPOSDUP
{
local ($section) = @_;
local ($CLnum, $LLnum, $line);
local (@PosDupLines, $count, $present);

	return if (!defined ($CLnum = $SecStart{uc $section}));
	die if (!defined($LLnum = $SecEnd{uc $section}) );

		# the section should contain exacly one non empty line
		# equal to "*PNP0500"

	$count = 0;
	$present = 0;
	while(++$CLnum < $LLnum)
	{
		$line = $INFlines[$CLnum];
		if (! defined($line))
		{ next; }
		$count++;
		if ($line =~ /^*PNP0500$/i)
		{	$present++; }
	}

	if ($count == 0)
	{
		add_ref_err(3086, $LLnum-1, $section);
		return;
	}

	if ($present == 0)
	{
		add_ref_err(3087, $LLnum-1, $section);
		return;
	}

	if ($count > 1)
	{
		add_ref_err(3088, $LLnum-1, $section);
	}
}
#-------------------------------------------------------------
# 
# Checks [XXX.NORESDUP] section for SERENUM models. 
#
# Usage:
#	checkNORESDUP(NoResDupSection)
#
#-------------------------------------------------------------
sub 
checkNORESDUP
{
local ($section, $FlagErrs) = @_;
local ($CLnum, $LLnum, $line, @IDs, $Id);
local (@UnimodemIDs);

	@UnimodemIDs = ();
	if (!defined($FlagErrs))
	{
		$FlagErrs = 1;
	}

	return if (!defined ($CLnum = $SecStart{uc $section}));
	die if (!defined($LLnum = $SecEnd{uc $section}) );

		# the section should contains only UNIMODEM ids

	while(++$CLnum < $LLnum)
	{
		$line = $INFlines[$CLnum];
		if (! defined($line))
		{ next; }
		@IDs = &get_list($line, $CLnum, $FlagErrs);
		foreach $Id (@IDs)
		{
			if($Id =~ /^__QUOTED_STR_\(([0-9]*)\)__$/)
			{
				$Id = $AllQuotes{$1};
				inst_err(1051, $CLnum);
			}
			if ($Id =~ /$^/)
			{
				inst_err(1027, $CLnum) if ($FlagErrs == 1);
				next;
			}
			if( $Id !~ /^UNIMODEM(.*)/i)
			{
				# "%s: Only UNIMODEM ids allowed in NORESDUP section."
				add_ref_err(3102, $CLnum, $Id) if ($FlagErrs == 1);
			}
			else
			{	push(@UnimodemIDs, $Id) if (defined($AllIDList{uc $Id})); }
			if (!defined($AllIDList{uc $Id}))
			{
				add_ref_err(1035, $CLnum, $Id) if ($FlagErrs == 1);
			}
		}
	}
	@UnimodemIDs;
}
#-------------------------------------------------------------
# 
# Process the sections defined by ADDREG keyword for each install section. 
#
# Usage:
#	CheckInstSections()
#
#-------------------------------------------------------------
sub 
CheckInstSections
{
local (%Inst_HKR, $sec_name, @sec_list, $RefListKeywords, $RefSectList, $CLnum);
local ($sec, $LLnum);
local($key, $value, $RefHashAddReg, @InstallResponses);
local(%ErrSpeedReport);


	%ErrSpeedReport = ();		# global used by proc_resp() procedure to flag only one error 
									# for a speed error

	while (($sec, $RefListKeywords)	= each %InstList)
	{
		next if (!defined($LLnum = $SecEnd{$sec}));

		if (!defined($RefSectList = ${$RefListKeywords}{'ADDREG'} ) )
		{ 
#			add_ref_err("Keyword ADDREG not defined.", $LLnum-1);
			add_ref_err(3042, $LLnum-1);
			next;
		}

		@sec_list = @{$$RefSectList[0]};
		$CLnum = $$RefSectList[1];

		%Inst_HKR = ();
		@InstallResponses = ();
		foreach $sec_name (@sec_list)
		{
			next if ($sec_name =~ /^$/); # check for blank names.

			$sec_name = uc $sec_name;

			AddRegProc($sec_name);		 # process the AddReg sections.

			# add new_HKR to the list of HKR for this model

			$RefHashAddReg = ${$AddRegList{$sec_name}}[0]; 
			while (($key, $value) = each(%{$RefHashAddReg}))
			{
				# The later entries can overwrite the former ones automatically!

				$Inst_HKR{$key} = $value ;
			}
			if (defined(@{${$AddRegList{$sec_name}}[1]}))
			{
				push(@InstallResponses, @{${$AddRegList{$sec_name}}[1]});
			}

			# Flag Install section if PCMCIA
			if ($sec_name =~ /^PCMCIA$/)
			{	$InstallTypeList{$sec} = $InstallType'PCMCIA_INST; }
		} 

		ProcInstall($CLnum, $sec, %Inst_HKR);
	}

		# Analyse all sections for response patternd
	CheckResponsePatterns();

	if ($ShortErrorReport == 1)
	{
		local($SpeedErrorKey, $RefSpeedError);

		while(($SpeedErrorKey, $RefSpeedError) = each %ErrSpeedReport)
		{		
			local($count);
			$count = keys %{$$RefSpeedError[0]};
			if ($SpeedErrorKey =~ /^DCE/)
			{
				add_ref_wrn(4020, $$RefSpeedError[3], "$count responses in $$RefSpeedError[1] models", 
									$$RefSpeedError[2]);
				next;
			}
			if ($SpeedErrorKey =~ /^DTE/)
			{
				add_ref_wrn(4051, $$RefSpeedError[3], "$count responses in $$RefSpeedError[1] models", 
									$$RefSpeedError[2]);
				next;
			}
		}
	}

}

#------------------------------------------------------------
# Check if minimal install keys present
#	for voice modem ("Voice" in the friendly name ?)
# Use %VoiceInstallList filled up in &voice_minimal_keys()
#------------------------------------------------------------
sub
CheckVoice
{
local($CLnum, $ModemKey, $ModemRef, $InstallSection, $ModemName);

	while (($ModemKey, $ModemRef) = each %ModelList)
	{
		$InstallSection = $$ModemRef[1];
		$ModemName	= $FStr{uc $$ModemRef[0]};
		$CLnum	= $$ModemRef[6];

		next if (!defined($ModemName));
		next if ($ModemName !~ /VOICE/i);

		if (! defined($VoiceInstallList{uc $InstallSection}) )
		{	
			add_ref_err(3106, $CLnum, $$ModemRef[0]);
		}
	}
}

#################################################################
#
# Helper subs....
#
#################################################################

#------------------------------------------------------------
# Checks validity of the R0/R1 id.
#	- check for correct length of Unimodem ID.
#	- returns a predefined constant corresponding to the type of ID
#	package $IdType
#		- UNIMODEM_ID
#		- PCMCIA_ID
#		- SERENUM_ID
#		- ISAPNP_ID		(not used anymore)
#		- STAR_ID
#		- BIOS_ID		(not used anymore)
#		- MF_ID
#		- UNKNOWN_ID
#
# Usage:
#		checkR0(ID, model, line_num)
#------------------------------------------------------------

sub checkR0
{
local($ID, $model, $Lnum) = @_;
local($Type);

	$Type = $IdType'UNKNOWN_ID;

	if ($ID =~ /^UNIMODEM(.*)/) 		# id must be 8 chars
	{ 
#		add_ref_err("UNIMODEM id is not of the expected length.", $Lnum) 
		add_ref_err(3043, $Lnum) 
			if (length($1) != 8);
		$Type = $IdType'UNIMODEM_ID;
	}
	elsif ($ID =~ /^ISAPNP\\/)
	{
		inst_err(3038, $Lnum);
#		$Type = $IdType'ISAPNP_ID;
	}
	elsif ($ID =~ /^SERENUM\\/)
	{
		$Type = $IdType'SERENUM_ID;
	}
	elsif ($ID =~ /^PCMCIA\\/)
	{
		$Type = $IdType'PCMCIA_ID;
	}
	elsif ($ID =~ /^BIOS\\/)
	{
		inst_err(3040, $Lnum);
#		$Type = $IdType'BIOS_ID;
	}
	elsif ($ID =~ /^\*/)
	{
		$Type = $IdType'STAR_ID;
	}
	elsif ($ID =~ /^MF\\/)
	{
		$Type = $IdType'MF_ID;
	}

	$Type; # return value

}


#------------------------------------------------------------
# Puts the given R0 id in the list of global R0 ids.
#
# Clobals changed:
#		GlobalR0List
# Usage:
#		AddGlobR0(ID)
#------------------------------------------------------------


sub
AddGlobR0
{
local($ID, $CLnum) = @_;

	# print "$infile: $ID\n";
	if (defined ($val = $GlobalR0List{uc $ID}))
	{
		add_ref_err(3105, $CLnum, $ID, $val);
		$GlobalR0List{uc $ID} = join(", ", $val, $infile." (line $CLnum)");
	} else {
		$GlobalR0List{uc $ID} = $infile." (line $CLnum)";
	}
}

#------------------------------------------------------------
# This sub prints the Rank0 errors. (modem specifc)
#
# Usage: 
#------------------------------------------------------------
sub
print_err_R0
{

	print "<h2>Duplicate Rank0 ids</h2>\n";
	print "<pre><table>\n";
	foreach $str (@StrR0Errs)
	{
		print $str;
	}
	print "</table></pre>\n";

}


#------------------------------------------------------------
# Checks if the INF is empty: no manufacturers, no Addreg, no Properties lines
#
# Usage: EmptyINF()
#------------------------------------------------------------
sub
EmptyINF
{
local($CLnum, $line);

	$CLnum = 0; # holds current line num.

	while(++$CLnum <= $TotalLines)
	{
		$line = $INFlines[$CLnum];
		next if (!defined($line));

		$line =~ s/[\s\t]//g; 
		return if ($line =~ /^HKR,,Properties/i);
		return if ($line =~ /^AddReg=/i);
	}
	add_ref_err(3090, $TotalLines);
}

1; # To tell require this file is okay.
